export default class {
  logDisabled() {
    return true;
  }

  execute(properties, component) {
    if (Utils.settings.isDev) {
      return;
    }

    const firebase = window.firebase;
    if (Utils.type.isObject(firebase)) {
      const params = properties.params;
      const suffix = params.referer_group ? "w/ referer" : "w/o referer";
      params.build_env = Utils.settings.env;
      // params.build_version = Utils.settings.appVersion;
      console.debug(`Logging ${suffix}:`, properties.name, params);
      firebase.analytics().logEvent(properties.name, params);
    } else {
      console.debug("Waiting for firebase to be initialized...");
      setTimeout(() => {
        this.execute(properties);
      }, 100);
    }
  }
}
