export default class {
  execute(spec, component) {
    return new Promise(resolve => {
      GLib.http.execute(
        spec,
        "GET",
        component,
        (page, response) => {
          this.handleSuccess(page, spec, component);
          resolve({ page: page, response: response });
        },
        (error, response) => {
          resolve({ error: error, response: response });
        }
      );
    });
  }

  handleSuccess(page, spec, component) {
    const currentUrl = window.location.href;

    Utils.type.ifString(spec.historyUrl, historyUrl => {
      const cleanUrl = Utils.url.htmlUrl(historyUrl);
      if (cleanUrl !== currentUrl) {
        const data = Object.assign({}, page, {
          replayGetResponse: page.onResponse
        });

        Utils.history.pushPage(data, cleanUrl);
      }
    });
    GLib.action.handleResponse(page, component);
  }
}