// Scroll the main body of the current window
export default class {
  execute(spec, component) {
    const pageBody =
      Utils.launch.dialog.closestBody(component) || Utils.history._pageBody;

    const selector = `#${spec.viewId}`;
    console.debug("Scrolling to", selector);
    const element = pageBody.querySelector(selector);

    let alignment = "center"
    switch (spec.placement) {
      case "top":
        alignment = "start"
        break;
      case "bottom":
        alignment = "end"
        break;
    }

    // this.scrollIfNeeded(element, spec, component);
    this.scrollIfNeeded(element, spec, component, alignment);

    element.classList.add("glib-scrollto");
    element.classList.add("glib-scrollto--highlighted");
  }

  // From https://gist.github.com/hsablonniere/2581101
  // scrollIfNeeded(element, spec, component, centerIfNeeded = true) {

  scrollIfNeeded(element, spec, component, alignment) {
    const vm = this;
    const observerOptions = {
      threshold: 1 // Trigger callback when 100% of the element becomes/unbecomes visible
    };
    new IntersectionObserver(function([entry]) {
      const ratio = entry.intersectionRatio;

      if (ratio < 1) {
        // const place = ratio <= 0 && centerIfNeeded ? "center" : "nearest";
        const place = ratio <= 0 ? alignment : "nearest";
        element.scrollIntoView({
          block: place,
          inline: place,
          behavior: spec["animate"] ? "smooth" : "auto",
        });
      } else {
        if (spec.force) {
          element.scrollIntoView({
            block: alignment,
            inline: alignment,
            behavior: spec["animate"] ? "smooth" : "auto",
          });
        }
        vm.onScrollEnd(element, spec, component);
        this.disconnect();
      }
    }, observerOptions).observe(element);
  }

  onScrollEnd(element, spec, component) {
    setTimeout(() => {
      element.classList.remove("glib-scrollto--highlighted");
    }, 300); // Allow time so the changes can be seen by human eyes.
    GLib.action.execute(spec.onScroll, component);
  }
}
