import { vueApp } from "../../store";

export default class {
  execute(properties, component, params) {
    Utils.type.ifString(properties.topic, topicName => {
      const ws = vueApp.webSocket;
      const channel = ws.channels[topicName];

      Utils.type.ifString(properties.event, eventName => {
        if (channel) {
          const payload = Object.assign({}, properties.payload, ws.header, {
            formData: properties.formData
          });
          console.debug(`Pushing to '${topicName}/${eventName}'`, payload);
          channel
            .push(eventName, payload)
            .receive("ok", resp => {
              console.debug(
                `Push to '${topicName}/${eventName}' succeeded`,
                resp
              );
              Utils.ws.handleResponse(resp.onResponse, component);
            })
            .receive("error", resp => {
              console.debug(`Push to '${topicName}/${eventName}' failed`, resp);
              Utils.ws.handleResponse(resp.onResponse, component);
            });
        } else {
          console.error(`Topic not joined: '${topicName}'`);
          Utils.launch.snackbar.error(
            "Something went wrong and we have been notified",
            component
          );
        }
      });
    });
  }
}
