import { Vue } from "../..";

import 'chartkick/chart.js';

import VueChartkick from 'vue-chartkick';
Vue.use(VueChartkick);


const multipleDataSeries = (dataSeries) => {
    return dataSeries.map((value) => {
        let points = null;
        if (Array.isArray(value.points)) {
            points = value.points.reduce((prev, curr) => {
                return Object.assign(prev, { [curr.x]: curr.y });
            }, {});
        } else {
            points = value.points;
        }
        return { name: value.title, data: points };
    });
};

const singleDataSeries = (dataSeries) => dataSeries.reduce((prev, curr) => Object.assign(prev, { [curr.title]: curr.value }), {});


export { multipleDataSeries, singleDataSeries };