function gmapInitializerFactory(options) {
  const baseUrl = "https://maps.googleapis.com";
  const googleMapScript = document.createElement("SCRIPT");

  Object.assign(options, { callback: '_glibGoogleMapCallback' });

  window._glibGoogleMapCallback = () => {
    window._gmapLoaded = true;
  };

  const query = Object.keys(options).map((key) => {
    if (options[key]) {
      return `${encodeURIComponent(key)}=${encodeURIComponent(
        options[key]
      )}`;
    }
    return "";
  }).join("&");
  const url = `${baseUrl}/maps/api/js?${query}`;
  googleMapScript.setAttribute("src", url);
  googleMapScript.setAttribute("async", "");
  googleMapScript.setAttribute("defer", "");
  document.head.appendChild(googleMapScript);
}

export const gmapPlugin = {
  install: (app, options) => {
    gmapInitializerFactory(options);
  }
};