export default {
  install: (Vue, options) => {
    Vue.mixin({
      methods: {
        $ready() {
          let spec = this.spec;
          if (spec && spec.id && this.$registryEnabled()) {
            const id = spec.id;
            const existingComponent = GLib.component.findById(id);
            // A component with the same ID in a different page shouldn't be considered a
            // duplicate. See `utils/components#deregister` for more details.
            if (existingComponent) {
              console.warn(
                "Duplicate component ID:",
                id,
                "Existing:",
                GLib.component.vueName(existingComponent),
                "New:",
                GLib.component.vueName(this)
              );
            }
            GLib.component.register(id, this);
          }
        },
        $tearDown() {
          let spec = this.spec;
          if (spec && spec.id && this.$registryEnabled()) {
            GLib.component.deregister(spec.id, this);
          }
        },
        $registryEnabled() {
          // Common classes such as `_select` need to return false so that it doesn't override its parent (e.g. `select`).
          return true;
        }
      }
    });
  }
};
