import { reactive } from 'vue';

export const vueApp = reactive({
    page: window.__page,
    indicator: false,
    // Rename to isPageStale
    isStale: false,
    /// Dirty form handling
    isFormSubmitted: false,
    isFormDirty: false,
    stateUpdatedAt: null,
    webSocket: { channels: {}, header: {} },
    actionCable: null,
    registeredComponents: [],
    temp: {},
    richTextValues: {},
    draggedComponent: null
});

export const dialogStates = reactive([]);

export const ctx = () => dialogStates.slice(-1)[0] || vueApp;

export const glibevent = reactive({
    onbeforewindowsopen: null,
    onbeforewindowsclose: null,
    onbeforewindowsreload: null
});

export function executeGlobalEvent(name) {
    if (!glibevent[name]) {
        return true;
    }

    return glibevent[name]();
}