const colors = ['primary', 'secondary', 'success', 'warning', 'info', 'error']
const variants = ['text', 'flat', 'elevated', 'outlined', 'plain', 'tonal']
const densities = ['comfortable', 'compact']
const sizes = ['x-small', 'small', 'large', 'x-large']

function determineColor(styleClasses, defaultColor) {
  const classes = styleClasses || []
  for (const value of colors) {
    if (classes.includes(value)) {
      return value;
    }
  }
  return defaultColor
}

function determineVariant(styleClasses, defaultVariant) {
  const classes = styleClasses || []
  for (const value of variants) {
    if (classes.includes(value)) {
      return value;
    }
  }
  return defaultVariant
}

function determineDensity(styleClasses, defaultDensity) {
  const classes = styleClasses || []
  for (const value of densities) {
    if (classes.includes(value)) {
      return value;
    }
  }
  return defaultDensity
}

function determineSize(styleClasses, defaultSize) {
  const classes = styleClasses || []
  for (const value of sizes) {
    if (classes.includes(value)) {
      return value;
    }
  }
  return defaultSize
}

export { colors, variants, determineColor, determineVariant, determineDensity, determineSize }

