import { marked } from "marked";

export default class {
  static markdownForEditor(text) {

    const renderer = {
      listitem(text, task, checked) {
        return `<li>${text.replace(/\<p\>|\<\/p\>/g, "")}</li>`;
      },
      list(body, ordered, start) {
        if (ordered) {
          return `<ol>${body}</ol>`;
        } else {
          return `<ul>${body}</ul>`;
        }
      }
    };

    marked.use({ renderer });

    return marked.parse(
      text, { break: true }
    );
  }

  static markdown(text) {
    return marked.parse(text);
  }

  static local_iso8601(date) {
    // See https://stackoverflow.com/a/29774197
    const offset = date.getTimezoneOffset();
    return new Date(date.getTime() - offset * 60 * 1000).toISOString();
    // return yourDate.toISOString().split("T")[0];
  }
}
