import config from '../package.json';

class MutableSettings {
  constructor() {
    this.reactive = true;
    this.themes = {};
    this.gtagId = null;
    this.errorHandler = (err, message) => {
      console.error(message || err.message);
    };
    this.headerAugmenter = (_url, _method) => {
      // Set a custom augmenter to add custom HTTP headers.
      return {};
    };
  }
}
const settings = new MutableSettings();
export { settings };

export default class ImmutableSettings {
  static get reactive() {
    return settings.reactive;
  }

  static get themes() {
    return settings.themes;
  }

  static get errorHandler() {
    return settings.errorHandler;
  }

  static get headerAugmenter() {
    return settings.headerAugmenter;
  }

  static get env() {
    return process.env.NODE_ENV;
  }

  static get appVersion() {
    return config.version;
  }

  // static get build() {
  //   switch (this.env) {
  //     case 'development':
  //       return new DevBuild()
  //     default:
  //       return new ProdBuild()
  //   }
  // }

  static get assetCdn() {
    return `${this.build.assetDomain}/${this.appVersion}`;
  }

  static get apiHost() {
    return this.build.apiDomain;
  }

  static get isDev() {
    return this.env == "development";
  }
}
